unit Unit1;
{
  Xfont96
  96 * 96 pixels font
  scalable, fontstyles.
  horizontal stripe encoding
 -----------------------------------------
 the Xfont96 developer provides custom made fonts
 - paint of new characters
 - use of existing characters (shifted, magnified, modified)
 font is saved
 - on disc as .DAV file
 - saved in bitmap format as   fontname_map.bmp

 character is encoded as a list of (10 bit) "stripe" codes:
 (a stripe is a horizontal line of pixels)

 000 ---Y---   set Y  (top of stripe in pixels)
 001 ---X1--   set X1 (left of stripe)
 010 ---X2--   setX2  (right of stripe)
 011 --cnt--   PR cnt (paint cnt stripes y,y+1,.... , dx1,2 = 0
 10 -dx1 -dx2  PI dx1,dx2 (paint stripe, x1+dx1,x2+dx2)
 11 -xp- -yp-  XY xp,yp (select x,y partitions for pixel alignment)

 stripe codes are placed in the "stripe list" of 32 bit DWORDS

 1......|--------|--code--|-width--|-length-|
 2......|--------|-bottom-|---top--|-hspace-|     (character layout)
 3......|----|-----H4|-----H3|-----H2|-----H1|    (horizontal slides positions)
 4......|----|-----V4|-----V3|-----V2|-----V1|    (vertical slides positions)
 5..etc.|--|--------S3|--------S2|--------S1|      (packed stripe codes)

 stripe lists are placed in "fontlist" that holds complete font

 1......|----Xres|----Yres|-----file length|       (resolutions, length)
 2......|-----rev|----Atop|----atop|---Ybase|      (general character layout)
 3......|------C4|------C3|------C2|------C1|      (name characters 1..4)
 4......|------C8|------C7|------C6|------C5|      (name characters 5..8)
 5..etc.|--|--------S3|--------S2|--------S1|      (packed stripe codes)

 buttons:

 Xlate : translates image and builts stripelist
 STORE : place stripelist in fontlist
 LOAD  : reads stripelist from fontlist
 DELETE: deleted stripe codes from forntlist

 OPEN  : reads fontlist from disc
 SAVE  : saves fontlist to disc
 SAVE in BITMAP : stores fontlist in bitmap on disc, as fontname_map.bmp
                  (for use as resource,in line code, in applications)
 EDIT  : allows modification of character image
 LOADIMAGE : load bitmap from disc in editbox

 -----------------------------------------
  unit1:
  low level painting, menu's, event processing
 -----------------------------------------
  sept. 2011:
  added loadimage button
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons, davArrayBtn;

type
  TForm1 = class(TForm)
    editBox: TPaintBox;
    Xpos: TStaticText;
    Ypos: TStaticText;
    Label1: TLabel;
    Label2: TLabel;
    wBox: TPaintBox;
    Label3: TLabel;
    fontbox: TComboBox;
    wcode: TStaticText;
    WcodeUpDown: TUpDown;
    Label4: TLabel;
    wheight: TStaticText;
    wheightUpdown: TUpDown;
    Label5: TLabel;
    wbias: TStaticText;
    wbiasUpDown: TUpDown;
    Label6: TLabel;
    wbold: TCheckBox;
    wUpDown10: TUpDown;
    Label7: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label8: TLabel;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    Vbox: TPaintBox;
    Hbox: TPaintBox;
    VImage: TImage;
    Himage: TImage;
    upBtn: TSpeedButton;
    rightBtn: TSpeedButton;
    downBtn: TSpeedButton;
    leftBtn: TSpeedButton;
    mainBtn: TDavArrayBtn;
    fontnameedit: TEdit;
    Label9: TLabel;
    Revisionedit: TEdit;
    Label10: TLabel;
    mathbox: TPaintBox;
    Label11: TLabel;
    Mcode: TStaticText;
    mcodeUpDown: TUpDown;
    mcodeUpDown10: TUpDown;
    Label12: TLabel;
    Label13: TLabel;
    heightlabel: TStaticText;
    HeightUpDown: TUpDown;
    Label14: TLabel;
    xlateBtn: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    Label15: TLabel;
    widthEdit: TEdit;
    Label16: TLabel;
    hleftlabel: TStaticText;
    Label17: TLabel;
    vtoplabel: TStaticText;
    Label18: TLabel;
    loadBtn: TSpeedButton;
    storeBtn: TSpeedButton;
    italicBtn: TSpeedButton;
    boldbtn: TSpeedButton;
    widebtn: TSpeedButton;
    Vbottomlabel: TStaticText;
    Label19: TLabel;
    tablelengthlabel: TStaticText;
    Label20: TLabel;
    Label21: TLabel;
    SpeedButton10: TSpeedButton;
    SpeedButton17: TSpeedButton;
    clearSlideBtn: TSpeedButton;
    msglabel: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    backgrBtn: TSpeedButton;
    SpeedButton19: TSpeedButton;
    Label22: TLabel;
    XresLabel: TStaticText;
    XresUpDown: TUpDown;
    Label23: TLabel;
    Timer1: TTimer;
    chDelBtn: TSpeedButton;
    mwidthlabel: TStaticText;
    Label24: TLabel;
    chcode: TStaticText;
    Label25: TLabel;
    editmodeBtn: TDavArrayBtn;
    Label26: TLabel;
    OpenDialog2: TOpenDialog;
    procedure editBoxPaint(Sender: TObject);
    procedure editBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure WcodeUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure wboldClick(Sender: TObject);
    procedure wBoxPaint(Sender: TObject);
    procedure wUpDown10Click(Sender: TObject; Button: TUDBtnType);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure VboxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure HboxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure editBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure editBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mainBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure VboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure HboxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure HboxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure VboxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure mathboxPaint(Sender: TObject);
    procedure xlateBtnClick(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure mcodeUpDown10Click(Sender: TObject; Button: TUDBtnType);
    procedure italicBtnClick(Sender: TObject);
    procedure loadBtnClick(Sender: TObject);
    procedure storeBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure VboxPaint(Sender: TObject);
    procedure clearSlideBtnClick(Sender: TObject);
    procedure mainBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure HeightUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure SpeedButton19Click(Sender: TObject);
    procedure XresUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure Timer1Timer(Sender: TObject);
    procedure rightBtnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure rightBtnMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure chDelBtnClick(Sender: TObject);
    procedure mcodeUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure editmodeBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure editmodeBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

 Tmainbutton = (mbOpen,mbSave,mbBitmap,mbWindows,mbMath,mbImage,mbEdit,mbOff);
 TSlides = array[1..4] of byte;

procedure clearslides;
procedure paintHSlides(oldpos : integer);
procedure paintVSlides(oldpos : integer);

const InactPixelcolor = $a0ffff;
      baseline = 77;
      vtop1    = 16;
      vtop2    = 32;

var
  Form1: TForm1;
  Wmap : Tbitmap;
  MathMap : TBitmap;
  mainbutton : Tmainbutton = mbEdit;
  Hslides    : TSlides;
  Vslides    : TSlides;

  Xresolution : byte;

implementation

{$R *.dfm}

uses unit2,unit3,unit4,unit5;

type Teditmode = (emPixels,emRectangle,emColumn,emRow);
     TEboxEvent = (ebeDown,ebeMove,ebeUp);
     TEboxmouseBtn = (embNone,embLeft,embRight);

const fractionline = 55;
      hleft = 12;
      gridcolor1 = $e0e0e0;
      gridcolor2 = $ff0000;
      SlideBGcolor = $f0ffff;

var Eboxmousebtn : TEboxmouseBtn;
    slideNr    : byte = 0; //selected slide 1..6 for (x,y)
    timercode : byte = 0;
    editmode : Teditmode;

    mouseX1,mouseY1,mouseX2,mouseY2 : integer; //pixel editing
    editrect : Trect;

procedure windowschar;
//paint windows character in wmap, copy to wbox
var cc : char;
    bias : integer;
begin
 with wmap do with canvas do
  begin
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   brush.Style := bsClear;
   font.Name := form1.fontbox.items[form1.fontbox.itemindex];
   font.Height := form1.wheightUpDown.position;
   if form1.wbold.Checked then font.Style := [fsBold] else font.Style := [];
   cc := chr(form1.wcodeUPDown.position);
   bias := form1.wbiasUpDown.position;
   textout(0,bias,cc);
  end;
 form1.wBox.canvas.draw(0,0,wmap);
 wcodeToEmap;
 emapToEditbox;
end;

//-- slides --

procedure clearslides;
//clear partition slides hor,vert
var i : byte;
begin
 for i := 1 to 4 do
  begin
   HSlides[i] := 0;
   VSlides[i] := 0;
  end;
end;

procedure sortslides(var sl : TSlides);
var i,j,hh : byte;
begin
 for i := 1 to 3 do
  for j := i+1 to 4 do
   begin
    if sl[i] = sl[j] then sl[j] := 0;
    if (sl[i] = 0) or ((sl[j] > 0) and (sl[i] > sl[j])) then
     begin
      hh := sl[i];
      sl[i] := sl[j];
      sl[j] := hh;
     end;
   end;
end;

//----

procedure clrMathMap;
begin
 with mathmap do with canvas do
  begin
   brush.Color := $ffffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
  end;
end;

procedure TForm1.chDelBtnClick(Sender: TObject);
//delete character from font list
var code : byte;
begin
 code := mcodeUpDown.Position;
 deleteChar(code);
 msglabel.Caption := 'character '+inttostr(code)+' deleted';
end;

procedure TForm1.XresUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
 Xresolution := XresUpDown.position;
end;

procedure TForm1.SpeedButton19Click(Sender: TObject);
//show math character enlarged
var i,j : byte;
begin
 for j := 0 to 95 do
  for i := 0 to 95 do painteboxfield(i,j,mathmap.Canvas.Pixels[i,j]);
end;

procedure TForm1.HeightUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
 setFontHeight(heightUpDown.Position);
 clrMathMap;
 paintstripelist;  //--> unit3
 mathbox.Invalidate;
end;

//----- edit box paints ------------

procedure paintEgrid(pmode : byte);
//pmode = 0 clears box
const edges : array[1..2] of word = (0,672);
var i  : byte;
    i7,pos : word;
begin
 with form1.editbox do with canvas do
  begin
   brush.Color := $ffffff;
   brush.Style := bsSolid;
   if pmode = 0 then fillrect(rect(0,0,width,height));
   i := 0;
   pen.Width := 1;
   while i <= 96 do    //horizontal lines
    begin
     i7 := i*7;
     case i of
      vtop1,                        //capitals top
      vtop2,                        //small chars top
      baseline,
      fractionline : pen.Color := gridcolor2;//baseline
      else pen.Color := gridcolor1;
     end;//case
     moveto(0,i7);
     lineto(width,i7);
     inc(i);
    end;//while
   i := 0;
   while i <= 96 do    //vertical lines
    begin
     i7 := i*7;
     case i of
      hleft : pen.color := gridcolor2;
      else pen.color := gridcolor1;
     end;//case
     moveto(i7,0);
     lineto(i7,height);
     inc(i);
    end;//while

//--- paint red lines for partitions ---

   pen.color := $ff;         //horizontal
   for i := 1 to 4 do
    begin
     pos := Hslides[i]*7;
     if pos <> 0 then
      begin
       moveto(pos,0);
       lineto(pos,672);
      end;
    end;//for

   for i := 1 to 4 do        //vertical
    begin
     pos := Vslides[i]*7;
     if pos <> 0 then
      begin
       moveto(0,pos);
       lineto(672,pos);
      end;
    end;//for

   for i := 1 to 2 do         //edges
    begin
     pos := edges[i];
     moveto(0,pos);
     lineto(672,pos);
     moveto(pos,0);
     lineto(pos,672);
    end;

  end;//with
end;  

procedure TForm1.editBoxPaint(Sender: TObject);
begin
 paintEgrid(0);
 EmaptoEditbox;
end;

procedure commonpaint;
//used by paintwindowsfont, paintmathfont
var i : byte;
    i42 : integer;
begin
 with form1.editBox do with canvas do
  begin
   brush.Color := $ffffff;
   brush.Style := bsSolid;
   pen.color := $000000;
   pen.Width := 1;
   rectangle(0,0,width,height);
   i := 1;
   while i < 16 do
    begin
     i42 := i*42;
     moveto(0,i42);
     lineto(width,i42);
     moveto(i42,0);
     lineto(i42,height);
     inc(i);
    end;
  end;
end;

procedure paintwindowsfont;
//in Editbox, 40*40
var i : byte;
begin
 commonpaint;
 with form1.editBox.Canvas do
  begin
   font.Name := form1.fontbox.Text;
   font.Color := $000000;
   font.Style := [];
   font.Height := 40;
   brush.Style := bsClear;
   for i := 0 to 255 do textout((i mod 16)*42,(i div 16)*42, chr(i));
  end;
end;

procedure paintmathfont;
//in EditBox, 40*40
var i : byte;
    rs,rd : Trect;
    base : word;
begin
 setFontHeight(40);
 commonpaint;
 rs.Left := 0;
 rs.top := 0;
 rs.Right := 40;
 rs.Bottom := 40;
 with mathmap.Canvas do
  begin
   brush.color := $ffffff;
   for i := 0 to 255 do
    begin
     base := fontIndex(i);
     if (fontlist[base] and $ff) <> 0 then
      begin
       brush.Style := bssolid;
       fillrect(rs);
       rd.Left := (i mod 16) * 42 + 1;
       rd.Right := rd.Left + 40;
       rd.Top := (i div 16) * 42 + 1;
       rd.Bottom := rd.Top + 40;
       XFcharOut1(0,0,@fontlist[base]);
       form1.editBox.Canvas.CopyRect(rd,mathmap.canvas,rs);
      end;
     end;//for
   end;//with

end;

//-- pixel editing --

procedure packrect;
//pack mouseX1,y2,x2,y2 into rectangle editrect
begin
 with editrect do
  begin
   if mouseX1 < mouseX2 then begin
                              left := mouseX1; right := mouseX2+1;
                             end
    else begin
          left := mouseX2; right := mouseX1+1;
         end;
   if mouseY1 < mousey2 then begin
                              top := mouseY1; bottom := mouseY2+1;
                             end
    else begin
          top := mouseY2; bottom := mouseY1+1;
         end;
  end;
end;

procedure adjustEmap;
//called on editbos, mouseUP & editmode = rectangle
//adjust emap to editrect
var i,j,data : byte;
begin
 if eboxmouseBtn = embleft then data := $f else data := 0;
 for i := editrect.left to editrect.right-1 do
  for j := editrect.top to editrect.bottom-1 do
   Emap[i,j] := data;
end;

procedure EditPixels(x,y : integer; event : TEboxEvent);
//set , clr pixels according to edit mode
//called by mouse events from Editbox
var data,i,j : byte;
    colr : DWORD;
begin
 if eboxMouseBtn = embLeft then
  begin
   data := $f;
   colr := $000000;
  end
  else
   begin
    data := 0;
    colr := $ffffff;
   end;
 case editmode of
  emPixels : begin
              Emap[x,y] := data;
              paintEboxField(x,y,colr);
             end; //emPixels
  emColumn : for i := 0 to 95 do
              begin
               Emap[x,i] := data;
               paintEboxfield(x,i,colr);
              end;
     emRow : for i := 0 to 95 do
              begin
               Emap[i,y] := data;
               paintEboxfield(i,y,colr);
              end;
emRectangle : begin
               case event of
                ebeDown : begin
                           mouseX1 := x; mouseY1 := y;
                           mouseX2 := x; mouseY2 := x;
                           packrect;
                          end;
                ebeMove : begin         //modify Emap later at mouseUP
                           mouseX2 := x; mouseY2 := y;
                           for i := editrect.left to editrect.Right-1 do
                            for j := editrect.Top to editrect.Bottom-1 do
                             if Emap[i,j] <> 0 then paintEboxfield(i,j,$0)
                              else painteboxfield(i,j,$ffffff);
                           packrect;
                           for i := editrect.left to editrect.Right-1 do
                            for j := editrect.Top to editrect.Bottom-1 do
                             paintEboxField(i,j,colr);
                          end;
               end;//case
              end;
 end;//case
end;

//------ editbox mouse events -------------

procedure TForm1.editBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if (mainbutton = mbEdit) and (editmode = emRectangle) then adjustEmap;
 EboxmouseBtn := embNone;
end;

procedure TForm1.editBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var xp,yp : integer;
    code : byte;
begin
 if mainbutton = mbEdit then
  begin
   xp := x div 7;
   yp := y div 7;
   if xp = 96 then xp := 95;
   if yp = 96 then yp := 95;
   if button = mbleft then eboxmouseBtn := embLeft
    else eboxmouseBtn := embRight;
   Editpixels(xp,yp,ebeDown);
 end;//if mainbutton

 if (mainbutton = mbWindows) or (mainbutton = mbMath) then
  begin
   xp := x div 42;
   yp := y div 42;
   code := xp + 16 * yp;
   clearslides;
   HBox.Invalidate;
   Vbox.Invalidate;
   paintEGrid(1);
  end;

 if mainbutton = mbWindows then
  begin
   wcodeUpDown.position := code;
   wUpDown10.position := (code div 10) * 10;
   windowschar;
  end; 

 if mainbutton = mbMath then
  begin
   mcodeUpDown.Position := code;
   mcodeupdown10.Position := (code div 10) * 10;
   loadBtnclick(self);
  end;

 if (mainbutton = mbMath) or (mainbutton = mbWindows) then
  begin
   mainBtn.btnDown(byte(mbEdit));
   mainbutton := mbEdit;
  end;

end;

procedure TForm1.editBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var Xp,Yp : integer;
    colr : longInt;
begin
 with editbox do
  if (x < 0) or (x >= width) or (y < 0) or (y >= height) then exit;

 if x = 672 then x := 671;
 if y = 672 then y := 671;
 xp := x div 7;
 yp := y div 7;
 xpos.Caption := inttostr(xp);
 ypos.Caption := inttostr(yp);

 if eboxMouseBtn <> embNone then editpixels(xp,yp,ebeMove);

 if (mainbutton = mbMath) or (mainbutton = mbWindows) then
  begin
   xp := x div 42;
   yp := y div 42;
   chcode.Caption := inttostr(xp + 16*yp); //show character code
  end;
end;

//---------- formcreate , destroy -------

procedure TForm1.FormCreate(Sender: TObject);
begin
 mainbutton := mbEdit;
 with fontbox do
  begin
   items := screen.Fonts;
   itemindex := items.indexof('arial');
  end;
 wmap := Tbitmap.Create;
 with wmap do
  begin
   pixelformat := pf32bit;
   width := 96;
   height := 96;
   canvas.Brush.Color := $ffffff;
   canvas.Font.color := $000000;
   canvas.Pen.Color := $f0f0f0;
  end;
 MathMap := TBitmap.Create;
 with mathMap do with canvas do
  begin
   pixelformat := pf32bit;
   width := 160;
   height := 120;
   Brush.color := $ffffff;
   Font.Color := $0;
   copymode := cmSRCcopy;
  end;
 editmodeBtn.BtnDown(0);//select pixelmode
 editmode := emPixels;
 Xresolution := XresUpDown.position;
 settextmap(mathmap);
 setXFCliprect(rect(0,0,mathmap.Width,mathmap.Height));
 leftBtn.caption := chr(172);
 rightBtn.caption := chr(174);
 UpBtn.caption := chr(173);
 DownBtn.caption := chr(175);
 clearslides;
 makepartitions(HSlides,HPartition,maxHcount);
 makepartitions(VSlides,VPartition,maxVcount);
 mainBtn.BtnDown(byte(mbEdit));
 setFontHeight(20);            //set mathfont properties
 setFontStyle(0);
 setFGcolor($000000);
 setBGcolor($ffc001);
 setCPUclock;
 msglabel.Caption := 'CPU clock: '+ formatfloat('####0',CPUCLOCK)+' MHz';
 windowschar;
 clearFontlist;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 wmap.free;
 wmap := nil;
 mathMap.Free;
 mathmap := nil;
end;

//------- windows character params -------------

procedure TForm1.WcodeUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
 wupdown10.Position := (wcodeupdown.Position div 10) * 10;
 windowschar;
end;

procedure TForm1.mcodeUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
 mcodeUpDown10.position := (mcodeUpDown.Position div 10) * 10;
end;

procedure TForm1.wboldClick(Sender: TObject);
begin
 windowschar;
end;

procedure TForm1.wBoxPaint(Sender: TObject);
begin
 wbox.Canvas.Draw(0,0,wmap);
end;

procedure TForm1.wUpDown10Click(Sender: TObject; Button: TUDBtnType);
begin
 wcodeUpDown.Position := wUpDown10.Position;
 windowschar;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
//show windows character in editbox
begin
 wcodeToEmap;
 emapToEditbox;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
//set treshold for wmap to editbox transfer
begin
 wtreshold := Tspeedbutton(sender).tag;
 windowschar;
end;

//--- slide paints --------------

procedure paintHSlides(oldpos : integer);
//erase oldpos arrow,line paint all slides
var r : Trect;
    pos : integer;
    i : byte;
begin
 pos := oldpos * 7;
 r.Left := pos - 6;
 r.Right := r.Left + 12;
 r.top := 0;
 r.Bottom := 16;
 if oldpos <> 0 then
  begin
   form1.HBox.canvas.brush.color := SlideBGcolor;
   form1.Hbox.Canvas.FillRect(r);
   form1.EditBox.canvas.pen.color := gridcolor1;
   form1.editbox.canvas.MoveTo(pos,0);
   form1.Editbox.canvas.LineTo(pos,672);
  end;
 for i := 1 to 4 do
  if HSlides[i] <> 0 then
   begin
    pos := HSlides[i]*7;
    form1.HBox.canvas.Draw(pos-6,0,form1.HImage.Picture.bitmap);
    form1.EditBox.canvas.Pen.color := $ff;
    form1.EditBox.canvas.MoveTo(pos,0);
    form1.EditBox.canvas.LineTo(pos,672);
  end;
end;

procedure paintVSlides(oldpos : integer);
//erase oldpos, paint slides , lines
var r : Trect;
    pos : integer;
    i : byte;
begin
 pos := oldpos * 7;
 r.Left := 0;
 r.Right := 16;
 r.Top := pos - 6;
 r.Bottom := r.Top + 16;
 if oldpos <> 0 then
  begin
   form1.VBox.canvas.brush.color := SlideBGcolor;
   form1.Vbox.Canvas.FillRect(r);
   form1.EditBox.canvas.Pen.color := gridcolor1;
   form1.EditBox.canvas.MoveTo(0,pos);
   form1.EditBox.canvas.LineTo(672,pos);
  end;
 for i := 1 to 4 do
  if VSlides[i] <> 0 then
   begin
    pos:= VSlides[i]*7;
    form1.Vbox.Canvas.Draw(0,pos-6,form1.VImage.Picture.bitmap);
    form1.editBox.Canvas.Pen.color := $ff;
    form1.editBox.Canvas.MoveTo(0,pos);
    form1.editBox.Canvas.LineTo(672,pos);
  end;
end;

//--- slide events ------------

procedure TForm1.HboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var pos,i : byte;
begin
 if mainbutton <> mbEdit then exit;

 pos := (x+3) div 7;
 if (pos = 0) or (pos = 96) then exit;

 i := 0;
 slideNr := 0;
 repeat                             //test for existing slide
  inc(i);
  if HSlides[i] = pos then slideNr := i;
 until (slideNr <> 0) or (i = 4);

 if slideNr <> 0 then
  begin
   if button = mbRight then        //delete slide
    begin
     HSlides[slideNr] := 0;
     slideNr := 0;
    end;
  end
  else
   begin
    i := 0;
    repeat                         //look for free slot
     inc(i);
     if HSlides[i] = 0 then
      begin
       slideNr := i;
       Hslides[slideNr] := pos;
       pos := 0;
      end;
    until (slideNr <> 0) or (i = 4);
   end;
 paintHSlides(pos);
end;

procedure TForm1.HboxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var oldpos,pos : integer;
begin
 pos := (x+3) div 7;
 Xpos.Caption := inttostr(pos);
 Ypos.Caption := '0';
 if slideNr = 0 then exit;

 if (pos < 0) or (pos >= 96) then pos := 0;
 oldpos := HSlides[slideNr];
 HSlides[slideNr] := pos;
 paintHSlides(oldpos);
end;

procedure TForm1.HboxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 sortslides(Hslides);
 if slideNr = 0 then exit;
 slideNr := 0;
 paintEgrid(1);
end;

procedure TForm1.VboxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var pos : integer;
    i : byte;
begin
 if mainbutton <> mbEdit then exit;

 pos := (y+3) div 7;
 if (pos = 0) or (pos = 96) then exit;

 i := 0;
 slideNr := 0;
 repeat                             //test for existing partition
  inc(i);
  if VSlides[i] = pos then slideNr := i;
 until (slideNr <> 0) or (i = 4);

 if slideNr <> 0 then               //delete slide
  begin
   if button = mbRight then
    begin
     VSlides[slideNr] := 0;
     slideNr := 0;
    end;
  end
  else
   begin                            //look for empty slot
    i := 0;
    repeat
     inc(i);
     if VSlides[i] = 0 then
      begin
       slideNr := i;
       VSlides[i] := pos;
       pos := 0;
      end;
    until (slideNr <> 0) or (i = 4);
  end;
 paintVslides(pos);
end;

procedure TForm1.VboxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var oldpos,pos : integer;
begin
 pos := (y+3) div 7;
 Xpos.Caption := '0';
 Ypos.Caption := inttostr(pos);
 if slideNr = 0 then exit;


 if (pos < 0) or (pos >= 96) then pos := 0;
 oldpos := VSlides[slideNr];
 Vslides[slideNr] := pos;
 paintVslides(oldpos);
end;

procedure TForm1.VboxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 sortslides(VSlides);
 if slideNr = 0 then exit;

 slideNr := 0;//drop selection
 paintEgrid(1);
end;

procedure TForm1.clearSlideBtnClick(Sender: TObject);
//clear the slides
begin
 clearSlides;
 Hbox.Invalidate;
 VBox.Invalidate;
 if mainbutton = mbEdit then paintEgrid(1);
end;

//--- Emap shifts , clear -------------

procedure EmapUp;
//shift Emap up
var i,j : byte;
begin
 for j := 0 to 94 do
  for i := 0 to 95 do Emap[i,j] := Emap[i,j+1];
 for i := 0 to 95 do Emap[i,95] := 0;
 EmaptoEditBox;
end;

procedure Emapright;
var i,j : byte;
begin
 for i := 95 downto 1 do
  for j := 0 to 95 do Emap[i,j] := Emap[i-1,j];
 for j := 0 to 95 do Emap[0,j] := 0;
 EmaptoEditBox;
end;

procedure EmapDown;
//shift emap down
var i,j : byte;
begin
 for j := 95 downto 1 do
  for i := 0 to 95 do Emap[i,j] := Emap[i,j-1];
 for i := 0 to 95 do Emap[i,0] := 0;
 EmaptoEditBox;
end;


procedure Emapleft;
//shift emap left
var i,j : byte;
begin
 for i := 0 to 94 do
  for j := 0 to 95 do Emap[i,j] := Emap[i+1,j];
 for j := 0 to 95 do Emap[95,j] := 0;
 EmaptoEditBox;
end;

procedure TForm1.rightBtnMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//common for Right,Up,Left,Down shift of Emap
begin
 timercode := TSpeedbutton(sender).Tag;
 case timercode of
  1  : Emapright;
  2  : EmapUp;
  3  : Emapleft;
  4  : EmapDown;
 end;
 timer1.Interval := 500;
 timer1.Enabled := true;
end;

procedure TForm1.rightBtnMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 timercode := 0;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 with timer1 do
  begin
   if Interval > 200 then interval := interval - 100;
   case timercode of
    0 : enabled := false;
    1 : EmapRight;
    2 : EmapUp;
    3 : EmapLeft;
    4 : EmapDown;
   end;
  end;
end;

//-- built stripe list

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
 clearEbox;
end;

procedure TForm1.xlateBtnClick(Sender: TObject);
begin
 if mainbutton <> mbEdit then exit;
 
 EmapToEditBox;//restore Ebox image before scanning
 makepartitions(HSlides,HPartition,maxHcount);
 makepartitions(VSlides,VPartition,maxVcount);
 makestripelist;
 clrMathMap;
 paintstripelist;  //--> unit3
 mathbox.Invalidate;
end;

//---- main button paint --------

procedure TForm1.mainBtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
const btnText : array[0..6] of string =
                ('open', 'save' , 'save(bitmap)', 'WinFont', 'MathFont',
                 'load image', 'edit');
var r : Trect;
    x,y : integer;
begin
 with mainBtn do with canvas do
  begin
   r := getBtnrect(BtnNr);
   font.name := 'arial';
   font.height := 18;
   if status = stFlat then font.style := [] else font.style := [fsBold];
   x := (btnWidth - textwidth(btntext[BtnNr])) div 2;
   y := (btnheight - textheight(btnText[btnNr])) div 2;
   textout(r.Left + x,r.Top + y,btnText[btnNr]);
  end;
end;

procedure TForm1.mathboxPaint(Sender: TObject);
begin
 mathBox.Canvas.Draw(0,0,mathMap);
end;

procedure TForm1.SpeedButton11Click(Sender: TObject);
begin
 heightUpDown.Position := TSpeedButton(sender).tag;
 setFontHeight(HeightUpDown.position);
 clrMathMap;
 paintstripelist;  //--> unit3
 mathbox.Invalidate;
end;

procedure TForm1.mcodeUpDown10Click(Sender: TObject; Button: TUDBtnType);
begin
 McodeUpDown.position := mcodeUpDown10.Position;
end;

procedure TForm1.italicBtnClick(Sender: TObject);
var code : byte;
begin
 if boldBtn.Down then code := XFbold else code := 0;
 if wideBtn.Down then code := code or XFwide;
 if italicBtn.down then code := code or XFitalic;
 if backgrBtn.down then code := code or XFbackground;
 setfontstyle(code);
 clrMathMap;
 paintstripelist;  //--> unit3
 mathbox.Invalidate;
end;

procedure TForm1.loadBtnClick(Sender: TObject);
//load stripe list from font list
begin
 clrMathMap;
 clearSlideBtnClick(self);
 if fontlist[fontIndex(mcodeUpDown.position)] = 0 then
  begin
   tablelengthlabel.caption := '0';
   vtoplabel.caption := '0';
   vbottomlabel.Caption := '0';
   widthedit.Text := '0';
   mathbox.Invalidate;
   exit;                            //no char stored
  end;

 loadChar(mcodeUpDown.position);//--> unit4 , load stripelist
 stripelistToEmap;    //copy stripes from list to Emap
 EmapToEditbox;
 setFontHeight(heightUpdown.position);
 paintstripelist;     //executes stripelist --> mathmap
 mathbox.invalidate;
end;

procedure TForm1.storeBtnClick(Sender: TObject);
//store stripe list in font list
begin
 storeChar(mcodeUpDown.position); //--> unit4
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if activecontrol = widthEdit then
  if not (key in ['0','1','2','3','4','5','6','7','8','9',#08]) then key := #00;
end;

procedure getImage;
//import bitmap from disc
type PDW = array[0..95] of DWORD;
     PADW = ^PDW;
const treshold = $80;
var tempBM : Tbitmap;
    pix : DWORD;
    a,r,g,b : byte;
    x,y : byte;
    p : PADW;
    w,h : word;
begin
 with form1 do with opendialog2 do
  if execute then
   begin
    clearEbox;                 //set emamp[ , ] to 0
    tempBM := Tbitmap.Create;
    tempBM.LoadFromFile(filename);
    tempBM.PixelFormat := pf32bit;
    w := tempBM.Width;
    if w > 96 then w := 96;
    h := tempBM.Height;
    if h > 96 then h := 96;
    for y := 0 to h-1 do
     begin
      p := tempBM.ScanLine[y];
      for x := 0 to w-1 do
       begin
        pix := p^[x];
        r := (pix shr 16) and $ff;
        g := (pix shr 8) and $ff;
        b := pix and $ff;
        if (r <= treshold) or (g <= treshold) or (b <= treshold) then
         emap[x,y] := $ff;
       end;//for x
     end;//for y
    EmaptoEditbox;
    tempBM.Free;
    tempBM := nil;
   end;//if execute
end;

procedure TForm1.VboxPaint(Sender: TObject);
var r : trect;
begin
 with TPaintbox(sender) do
  begin
   r.Left := 0;
   r.Right := width;
   r.Top := 0;
   r.Bottom := height;
   canvas.Brush.Style := bsSolid;
   canvas.Brush.color := SlideBGcolor;
   canvas.FillRect(r);
  end;
 if sender = HBox then paintHslides(0);
 if sender = VBox then paintVslides(0);
end;

//-- menu --

procedure TForm1.mainBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 case mainbutton of       //closing actions
  mbOpen    :;
  mbSave    :;
  mbEdit    :;
  mbMath    :;
  mbWindows :;
  mbBitmap  :;
  mbImage   :;
 end;
 mainbutton := mbOff;
 if status = stDown then  //opening actions
  begin
   mainbutton := TMainButton(BtnNr);
   case mainbutton of
    mbOpen   : begin
                OpenFont;
                mainBtn.BtnRelease(byte(mainbutton));
                mainbutton := mbOff;
                editbox.Invalidate;
               end; 
    mbSave   : begin
                saveFont;
                mainBtn.BtnRelease(byte(mainbutton));
                mainbutton := mbOff;
                editbox.Invalidate;
               end;
    mbEdit   : Editbox.invalidate;
    mbMath   : paintmathfont;
    mbWindows: paintwindowsfont;
    mbBitmap : begin
                saveFontInBitmap;
                mainBtn.BtnRelease(byte(mainbutton));
                mainbutton := mbOff;
               end;
    mbImage  : begin
                getImage;
                mainBtn.BtnDown(byte(mbEdit));
                mainbutton := mbEdit;
               end;
   end;
  end;
end;

//-- edit mode arraybutton

procedure Tform1.editmodeBtnBtnPaint(sender: TObject; BtnNr: Byte;
                                     status: TBtnStatus);
const emText : array[0..3] of string = ('pixels','rectangle','column','row');
      pp : array[0..15] of byte = (1,2,12,22,23,24,14,15,16,26,27,28,29,19,9,8);
var w,x1,x2,y1,y2 : byte;
    r : Trect;
 procedure mark(x,y : byte);
  begin
   with editmodeBtn do with canvas do
    begin
     x := r.left + 5 + 5*x;
     y := r.top + 5 + 5*y;
     fillrect(rect(x+1,y+1,x+5,y+5));
    end;
  end;

begin
 with editmodeBtn do with canvas do
  begin
   r := getBtnRect(BtnNr);
   font.Name := 'arial';
   font.height := 14;
   w := textwidth(emText[BtnNr]);
   x1 := (BtnWidth - w) div 2;
   brush.Style := bsClear;
   pen.Color := $ff8080;
   textout(r.left+x1,r.top+23,emText[BtnNr]);
   brush.Style := bsSolid;
   brush.Color := $0;
   //     rectangle(rect(r.Left+5,r.top+5,r.Left+55,r.Top+20));
   for w := 0 to 10 do       //vertical lines
    begin
     x1 := 5+r.Left+5*w;
     y1 := r.top+5;
     y2 := y1 + 15;
     moveto(x1,y1);
     lineto(x1,y2);
    end;
   for w := 0 to 3 do        //horizontal lines
    begin
     x1:= r.Left+5;
     x2 := x1 + 50;
     y1 := r.top+5 + 5*w;
     moveto(x1,y1);
     lineto(x2,y1);
    end;

   case Teditmode(BtnNr) of
    emPixels    : for w := 0 to 15 do mark(pp[w] mod 10, pp[w] div 10);
    emRectangle : for w := 0 to 29 do mark(w mod 10, w div 10);
    emColumn    : for w := 0 to 2 do mark(5,w);
    emRow       : for w := 0 to 9 do mark(w,1);
   end;
 end;//with
end;

procedure TForm1.editmodeBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 editmode := Teditmode(BtnNr);
end;

end.
