unit Unit2;

{
  analysing
  processing the Emap array
  partitions
}

interface

uses types,sysutils,unit1;

type PDW = ^DWORD;
     TPartition = record
                      LT : integer; //left top of partition
                      RB : integer; //right bottom of partition
                  end;

     TPAR = array[1..5] of TPartition;

const maxStripeNr = 254;
      maxIntStripeNr = 750;

procedure wcodeToEmap;
procedure emaptoEditbox;
procedure paintEboxfield(x,y : byte; cr : longInt);
procedure clearEbox;
procedure makepartitions(var s : TSlides; var p : TPAR; var maxP : byte);
procedure makestripelist;
procedure paintstripelist;
procedure stripelistToEmap;

var wtreshold : byte = 128;
    Emap : array[0..95,0..95] of byte;
    Stripelist : array[1..maxstripeNr] of DWORD;

    Hpartition : TPAR; //0: total width
    Vpartition : TPAR; //0: total height
    maxHcount  : byte; //number of H partitions
    maxVcount  : byte; //--        V --

implementation

uses unit3,unit5;

type Tstripe = record
                x1 : byte;
                x2 : byte;
                 y : byte;
               end;

var IntStripelist : array[1..maxIntStripeNr] of word;
    IntStripeNr   : word;
    StripeNr      : byte;

//-- IntstripeList support -----

function activepartition(hp,vp : byte) : boolean;
//true if data in this partition
var i,j : byte;
begin
 result := false;
 for i := HPartition[HP].LT to HPartition[HP].RB-1 do
  for j := Vpartition[VP].LT to Vpartition[VP].RB-1 do
   if Emap[i,j] <> 0 then
    begin
     result := true;
     exit;
    end;
end;

function findstripe(var stripe : TStripe;hp,vp : byte) : boolean;
//return true if stripe in partition (HP,VP)
var i,j,k : byte;
begin
 for j := Vpartition[VP].LT to VPartition[VP].RB-1 do
  for i := HPartition[HP].LT to HPartition[HP].RB-1 do
   if EMap[i,j] = $f then
    begin
     k := 1;
     while (i+k < HPartition[HP].RB) and (EMap[i+k,j] = $f) do inc(k);
     stripe.x1 := i;
     stripe.x2 := i+k;
     stripe.y := j;
     result := true;
     exit;
    end;
 result := false;
end;

function matchstripe(var mc : byte; var old,new : Tstripe;
                     hp,vp : byte) : boolean;
var i,j,k : byte;
    dx1,dx2 : shortInt;
begin
 result := false;
 if old.y = VPartition[VP].RB - 1 then exit; //last stripe in partition

 j := old.y+1;
 for i := HPartition[HP].LT to HPartition[HP].RB-1 do
  if EMap[i,j] = $f then
   begin
    k := 1;
    while (i+k < HPartition[HP].RB) and (EMap[i+k,j] = $f) do inc(k);
    dx1 := i - old.x1;
    dx2 := i+k - old.x2;
    if (abs(dx1) < 8) and (abs(dx2) < 8) then
     begin
      new.x1 := i;
      new.x2 := i + k;
      new.y := j;
      mc := ((dx1 and $f) shl 4) or (dx2 and $f);//mc : move code
      result := true;
      exit;
     end;//if abs()
   end;//if Emap()
end;

procedure clearStripe(var str : TStripe);
var i,j : byte;
begin
 j := str.y;
 for i := str.x1 to str.x2 - 1 do Emap[i,j] := 1;
end;

procedure addDirector(data : word);
begin
 if IntStripeNr < maxintstripeNr then
  begin
   inc(IntStripeNr);
   IntStripeList[IntStripeNr] := data;
  end;
end;

//--- stripeList support ---

function getCharWidth : byte;
var i,j : byte;
begin
 for i := 95 downto 0 do
  for j := 0 to 95 do
   if Emap[i,j] <> 0 then
    begin
     result := i+1;
     exit;
    end;
 result := 0;
end;

function GetHSpace : byte;
var i,j : byte;
begin
 for i := 0 to 95 do
  for j := 0 to 95 do
   if Emap[i,j] <> 0 then
    begin
     result := i;
     exit;
    end;
 result := 96;
end;

function GetCharTop : byte;
var i,j : byte;
begin
 for j := 0 to 95 do
  for i := 0 to 95 do
   if Emap[i,j] <> 0 then
    begin
     result := j;
     exit;
    end;
 result := 96;
end;

function GetCharBottom : byte;
var i,j : byte;
begin
 for j := 95 downto 0 do
  for i := 0 to 95 do
   if Emap[i,j] <> 0 then
    begin
     result := j;
     exit;
    end;
 result := 0;
end;

procedure packSlides(slides : TSlides);
//pack slides into stripelist
//update stripeNr (= last DWORD entered)
var i : byte;
    dw : DWORD;
begin
 inc(stripeNr);
 dw := 0;
 for i := 1 to 4 do dw := dw or (slides[i] shl ((i-1)*7));
 stripelist[stripeNr] := dw;
end;

// --- generate IntStripelist ---> stripelist ---

procedure makestripelist;
//analyze Emap
//built Intermediate stripe list
//built stripe list
var oldstripe, newstripe : TStripe;
    movecode : byte;     //dx1,dx2
    v,w : word;
    b : byte;
    HP,VP : byte;
begin
 for v := 1 to maxIntStripeNr do IntStripeList[v] := 0;
 IntstripeNr := 0;
 with oldstripe do
  begin
   y := 0;
   x1 := 0;
   x2 := 0;
  end;
 for HP := 0 to 95 do
  for VP := 0 to 95 do
   if Emap[HP,VP] <> 0 then EMap[HP,VP] := $f; //reset Emap for scanning

 for HP := 1 to maxHcount do
  for VP := 1 to maxVcount do
   if activePartition(hp,vp) then
    begin
     if (HP <> 1) or (VP <> 1) then           //initial partition is (1,1)
      begin
       inc(IntstripeNr);
       Intstripelist[intStripeNr] := $300 or (HP shl 4) or VP;
      end;

     while FindStripe(newstripe,hp,vp) do
      begin
       if oldstripe.y <> newstripe.y then
        addDirector(newstripe.y);
       if oldstripe.x1 <> newstripe.x1 then
        addDirector($80 or newstripe.x1);
       if oldstripe.x2 <> newstripe.x2 then
        addDirector($100 or newstripe.x2);
       oldstripe := newstripe;
       clearStripe(oldstripe);
       while matchStripe(movecode,oldStripe,newstripe,hp,vp) do
        begin
         oldStripe := newstripe;
         AddDirector($200 or movecode);
         clearstripe(oldstripe);
        end;
       AddDirector($200); //last stripe in chain
       inc(oldstripe.y);
       end;//while
    end;//if partition

// -- compress $200,$200 codes to $180 + repeat count

  v := 1;
  while (v <= intStripeNr) do
   begin
    if IntStripelist[v] = $200 then    //look for $200 stripe code
     begin
      IntStripelist[v] := $181;        //set to PR 1
      while (v < IntStripeNr) and (IntStripelist[v+1] = $200) do
       begin
        inc(IntStripeList[v]);
        for w := v+1 to IntStripeNr-1 do IntstripeList[w]:=IntStripelist[w+1];
        IntStripelist[IntStripeNr] := 0;
        dec(IntStripeNr);
       end;//while
     end;  //if intStripeList[]
    inc(v);
   end;//while

//-- pack IntStripeList into StripeList

 for v := 1 to maxstripeNr do stripeList[v] := 0;

 stripeNr := 1;                               //pack stripe 1
 b := getCharwidth;
 form1.widthEdit.Text := inttostr(b);
 Stripelist[stripeNr] := b shl 8;
 StripeList[stripeNr] := stripeList[stripeNr] or
                         (form1.mcodeUpDown.Position shl 16);
 stripeNr := 2;                              //pack stripe 2
 b := getHSpace;
 form1.hleftlabel.Caption := inttostr(b);
 StripeList[stripeNr] := b;
 b := getCharTop;
 form1.vtoplabel.Caption := inttostr(b);
 stripelist[stripeNr] := stripelist[stripeNr] or (b shl 8);
 b := getCharBottom;
 form1.Vbottomlabel.Caption := inttostr(b);
 stripelist[stripeNr] := stripelist[stripeNr] or (b shl 16);
 packSlides(Hslides);             //increments stripeNr to last entry
 packslides(VSlides);             //----
 b := 4;                         //force stripeNr increment
 w := 1;                         //index to IntStripeList
 while w <= IntStripeNr do       //pack stripe codes
  begin
   if b > 2 then
    begin
     b := 0;
     if stripeNr < maxstripeNr then inc(stripeNr);
    end;
   if b = 0 then stripeList[stripeNr] := $c0000000;
   stripelist[stripeNr] := stripelist[stripeNr] or
                           (IntStripelist[w] shl (b*10));
   inc(b);
   inc(w);
  end;
 stripelist[1] := stripelist[1] or stripeNr;            //pack list length
 form1.tablelengthlabel.Caption := inttostr(stripeNr);
 if stripeNr = maxstripeNr then form1.tablelengthlabel.Caption := 'ERROR';
end;

procedure paintstripelist;
var t1,t2 : TI64;
    ft : extended;
begin
 if (stripelist[1] and $ff) = 0 then exit; //no stripes
 
 getCPUticks(t1);
 XFcharout1(0,0,@stripelist[1]);
 getCPUticks(t2);
 t1 := diff64(t1,t2); //t2 - t1
 ft := I64ToFloat(t1);//CPU ticks of process
 form1.msglabel.Caption := 'time = '+formatfloat('##0.0##',ft/CPUCLOCK)+' usecs';
 form1.mwidthlabel.Caption := inttostr(XFwidth);
end;

procedure makepartitions(var s : TSlides; var p : TPAR; var maxP : byte);
//use slides to make partitions array for scanning
var i : byte;
begin
 for i := 1 to 5 do       //clear partition
  with p[i] do
   begin
    LT := 0;
    RB := 0;
   end;

// -- count partitions (partitions = # slides + 1)

 maxP := 1;
 for i := 1 to 4 do if s[i] <> 0 then inc(maxP);

// -- setup Partitions

 p[1].LT := 0;
 i := 1;
 while (i <=4) and (s[i] > 0) do
  begin
   p[i].RB := s[i];
   p[i+1].LT := s[i];
   inc(i);
  end;
 p[i].RB := 96;
end;

procedure wcodeToEmap;
type  AR = array[0..400] of byte;
     PAR = ^AR;
var   p : PAR;
    i,j : byte;
    r,g,b : byte;
    i4,cc : word;
begin
 with wmap do
  for j := 0 to 95 do
   begin
    p := scanline[j];
    for i := 0 to 95 do
     begin
      i4 := 4*i;
      r := p^[i4+2];
      g := p^[i4+1];
      b := p^[i4];
      cc := (r + g + b) div 3;
      if cc < wtreshold then Emap[i,j] := $f else Emap[i,j] := 0;
     end; //for i
   end;//for j
end;

procedure emapToEditbox;
var i,j : byte;
    colr : longInt;
begin
 for j := 0 to 95 do
  for i := 0 to 95 do
   begin
    if Emap[i,j] <> 0 then colr := $000000
     else
      if i < Xresolution then colr := $ffffff else colr := inactPixelcolor;
    paintEboxField(i,j,colr);
   end;
end;

procedure paintEboxfield(x,y : byte; cr : longInt);
var r : trect;
begin
 r.left := x*7+1;
 r.right := r.left+6;
 r.top := y*7+1;
 r.bottom := r.top+6;
 with form1.editbox.Canvas do
  begin
   brush.Color := cr;
   fillrect(r);
  end;
end;

procedure clearEbox;
var i,j : byte;
begin
 for i := 0 to 95 do
  for j := 0 to 95 do Emap[i,j] := 0;
 emaptoeditbox;
end;

procedure stripelistToEmap;
//show stripelist in Emap, display Emap
//show slides
const sh : array[0..2] of byte = (0,10,20); //stripe shift count
var dc,i,j,rep : byte;
    stripe : word;
    delta : shortInt;
    DWstripe : DWORD;
    nr,maxNr : byte;
    x1,x2,y : byte;
begin
 if stripelist[1] = 0 then exit;//empty list

 clearEbox;
 nr := 1;
 maxNr := stripelist[nr] and $ff;
 form1.tablelengthlabel.Caption := inttostr(maxNr);
 form1.widthEdit.Text := inttostr((stripelist[1] shr 8) and $ff);
 x1 := 0;
 x2 := 0;
 y := 0;
 inc(nr);                                     // --> #2
 form1.hleftlabel.Caption := inttostr(stripelist[2] and $ff);
 form1.vtoplabel.Caption := inttostr((stripelist[2] shr 8) and $ff);
 form1.Vbottomlabel.Caption := inttostr((stripelist[2] shr 16) and $ff);
//---
 inc(nr);                                     // --> stripelist #3
 for i := 0 to 3 do HSlides[i+1] := (stripelist[nr] shr (i*7)) and $7f;
 paintHslides(0);
 inc(nr);                                     // --> stripelist #4
 for i := 0 to 3 do VSlides[i+1] := (stripelist[nr] shr (i*7)) and $7f;
 paintVslides(0);
 inc(nr);                                    // --> stripelist #5,6,7,...

 while nr <= maxNr do    //execute stripes list
  begin
   DWstripe := stripelist[nr];
   for dc := 0 to 2 do
    begin
     stripe := (DWstripe shr sh[dc]) and $3ff;
      case stripe and $380 of
       $000 : y := stripe and $7f;
       $080 : x1 := stripe and $7f;
       $100 : x2 := stripe and $7f;
       $180 : begin
               rep := stripe and $7f;
               for i := 1 to rep do
                begin
                 for j := x1 to x2-1 do Emap[j,y] := $f;
                 inc(y);
                end;
              end;
       $200,
       $280 : begin
               for j := x1 to x2-1 do Emap[j,y] := $f;
               delta := (stripe shr 4) and $f;
               if delta > 7 then delta := delta - 16;
               x1 := x1 + delta;
               delta := stripe and $f;
               if delta > 7 then delta := delta - 16;
               x2 := x2 + delta;
               inc(y);
              end;
       $300,
       $380 : ;
      end;//case stripe
     end;//for
   inc(nr);
  end;//while
end;

end.
